package org.apache.el.parser;

import javax.el.ELException;
import javax.el.VariableMapper;

import org.apache.el.lang.EvaluationContext;

public final class AstInvoke extends SimpleNode {

	public AstInvoke(int i) {
		super(i);
	}
	
	@Override
    public Object getValue(EvaluationContext ctx)
            throws ELException {
        Object obj1 = this.children[0].getValue(ctx);
        if(!(obj1 instanceof AstLambda)){
        	throw new ELException("Can not found Lambda in this context");
        }
        AstLambda lambda = (AstLambda)obj1;
        int length = lambda.children.length;
        if(length!=this.children.length){
        	throw new ELException("Params not match for Lambda");
        }
        Node body = lambda.children[length-1];
        //update ctx
        for(int i=1;i<this.children.length;i++){
        	AstIdentifier identifier = (AstIdentifier)(lambda.children[i-1]);
        	String image = identifier.getImage();
        	ctx.setLambdaLocal(image, this.children[i].getValue(ctx));
        }
        Object ret =  body.getValue(ctx);
        //reload ctx
        ctx.clearLambdaLocal();
        return ret;
    }

}
